/**
* Контроллер-сборщик данных (к проекту http://smartliving.ru/)
* Platform: Arduino UNO R3 + EthernetShield W5100
* IDE: Arduino 1.0.1
* Подключение датчиков температуры DS18x20 по схеме с нормальным питанием (пример http://sourceforge.net/apps/trac/arduios/wiki/owmon)
* данные (зеленый провод со схемы по ссылке указанной выше) подключаем на D2
* ВНИМАНИЕ! Для того чтобы у Вас заработало получение данных с детчиков температуры, нужно прописать адреса ваших датчиков (ниже по коду)
*
* Остальные датчики:
Digital 8 - Красный светодиод Сигнализирует что передача данных не удаась
* Digital 9 - Зеленый свнтодиод 
* 10-й, 11-й, 12-й, 13-й зарезервированы для общения с сетевым чипом по протоколу SPI
* 4-й зарезервирован для обращения к SD-модулю
* 2-й для обработки прерываний сетевого чипа ????
Digital 2 pin Arduino (куда подключен выход с шины датчиков DS18X20
analogInPin = A0; - считыватель показаний электро счетчика
Digital 9 - dht11
*
*
**/
#include <Ethernet.h>
#include <SPI.h>
#include <OneWire.h>
#include <DallasTemperature.h>
//#include <math.h>
#include "DHT.h"
#include <BMP085.h>
#include <Wire.h> 
#include <LiquidCrystal.h>
#include <EthernetUdp.h>
#include <SD.h>

BMP085 dps = BMP085();  

File webFile;

// MAC-адрес нашего устройства
byte mac[] = { 0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };

unsigned int localPort = 8888; 
IPAddress ip(192,168,1,177);
IPAddress timeServer(132, 163, 4, 101); // time-a.timefreq.bldrdoc.gov NTP server

const int NTP_PACKET_SIZE= 48; // NTP time stamp is in the first 48 bytes of the message

byte packetBuffer[ NTP_PACKET_SIZE]; //buffer to hold incoming and outgoing packets 

// A UDP instance to let us send and receive packets over UDP
EthernetUDP Udp;


// select the pins used on the LCD panel
LiquidCrystal lcd(8, 9, 26, 5, 6, 7);

//byte subnet[] = { 255, 255, 255, 0 };
//byte gateway[] = { 192, 168, 1, 1 };
//byte dns_server[] = { 192, 168, 1, 1 };
// ip-адрес удалённого сервера
//byte server[] = { 192, 168, 1, 201 };
EthernetServer server(80);


// Pin controller for connection data pin DS18S20
#define ONE_WIRE_BUS 2 // Digital 2 pin Arduino (куда подключен выход с шины датчиков DS18X20
#define TEMPERATURE_PRECISION 9
#define DHTPIN 3

#define DHTTYPE DHT11   // DHT 11 

DHT dht(DHTPIN, DHTTYPE);

OneWire oneWire(ONE_WIRE_BUS);
DallasTemperature sensors(&oneWire);

unsigned long Blink1;
unsigned long Blink2;
 
 const int analogInPin = A0;
 const int ledPin = 9;
 const int ledPinError = 8; //Красный светодиод Сигнализирует что передача данных не удаась
const int MaxTimeOutPower = 30;

boolean debug=true;
DeviceAddress Termometers;

// Инициализация начальных значений
float tempC;
int old_temperature1=0;
int old_light=0;
char buf[80];
char ipbuff[16];
int PowerOst; 
float current_temp1;
long lastReadingTime = 0;
long lastReadingTimePower = 0;
float hum =0;
float tempIn, tempIn_min, tempIn_max, current_temp1_min, current_temp1_max, hum_max, hum_min, cur_pressure_min,cur_pressure_max;
long Pressure = 0;
int cur_pressure;
boolean first= true;
unsigned long epoch, tempIn_max_time, tempIn_min_time, current_temp1_min_time, current_temp1_max_time, hum_max_time, hum_min_time,cur_pressure_min_time, cur_pressure_max_time;
// ------------------------------------------------------------------------------------------------



/**************************************************************************************************
*/
void searchDevices() {
  if (debug) {Serial.println("Start search on 1-wire");}
   int numberOfDevices = sensors.getDeviceCount();
   if (debug) {Serial.print("Searched 1-wire units: ");}
   if (debug) {Serial.println(numberOfDevices);}
  // sensors.begin();
   
   for(int i=0;i<numberOfDevices; i++) {
      if(sensors.getAddress(Termometers, i))
      {
          if (debug) {Serial.print("Found device ");}
	  if (debug) {Serial.print(i, DEC);}
          if (debug) {Serial.print(" with address: ");}
          for (uint8_t i = 0; i < 8; i++) {
            if (Termometers[i] < 16) Serial.print("0");
              if (debug) {Serial.print(Termometers[i], HEX);}
          }

          if (debug) {Serial.print("Resolution actually set to: ");}
          if (debug) {Serial.print(sensors.getResolution(Termometers), DEC);} 
          if (debug) {Serial.println();}
          float tempC = sensors.getTempC(Termometers);
          if (debug) {Serial.print(tempC);}
          if (debug) {Serial.println("C");}
      
      } else {
            // not found
      }
    }
}




/**************************************************************************************************
*/

// ------------------------------------------------------------------------------------------------
void setup()
{
  // Для дебага будем выводить отладочные сообщения в консоль
  Serial.begin(9600);
  Serial.println("Start");
 
  Ethernet.begin(mac, ip);
  server.begin();
  Serial.print("server is at ");
  Serial.println(Ethernet.localIP());
  
  Serial.println("DHTxx test!");
  dht.begin();
  //Инициация датчика давления
  Wire.begin(); 
  dps.init();

// Настройки 1-wire 
  sensors.begin(); // Инициализация шины 1-wire (для датчиков температуры)
  searchDevices();

 //Ethernet.begin(mac, ip, dns_server, gateway, subnet); // Инициализируем Ethernet Shield

 pinMode(ledPin, OUTPUT); // Светодтод
 //pinMode(ledPinError, OUTPUT); // Красный Светодтод
 //digitalWrite(ledPinError, LOW);
 
  Udp.begin(localPort);
 //////LCD
 lcd.begin(16, 2);              // start the library
 lcd.setCursor(0,0);
 lcd.print("Starting..."); // print a simple message   
 
 //инициализация сд карты
 pinMode(53, OUTPUT);
 Serial.println("Initializing SD card...");
    if (!SD.begin(4)) {
        Serial.println("ERROR - SD card initialization failed!");
        return;    // init failed
    }
    Serial.println("SUCCESS - SD card initialized.");
    // check for index.htm file
    if (!SD.exists("index.htm")) {
        Serial.println("ERROR - Can't find index.html file!");
       // return;  // can't find index file
    }
    Serial.println("SUCCESS - Found index.html file.");
 
 
 }


void GetTemp()
{
   // Перед каждым получением температуры надо ее запросить
  sensors.requestTemperatures();
  if (debug) {Serial.println("IN GetTemp");}
  int valid_sensor=0;

  delay(1000); // задержка в 1 сек.  


  // TEMP SENSOR 1 --------------------------------------
  current_temp1=0;
  sensors.getAddress(Termometers, 0);
  float tempC = sensors.getTempC(Termometers); // Получим температуру от датчика (или ошибку)
  if (tempC == DEVICE_DISCONNECTED) { 
    // Устройство отсоеденнено
    Serial.println("Termometer1 is DEVICE_DISCONNECTED");
    // TODO Послать бы на сервер сигнал о том, что датчит не отвечает
    
  } else {
    // Устройство отдало реальное значение температуры (или осталось старое)
   if (debug) { Serial.print("T1: ");}
    current_temp1 = tempC; // получаем температуру
    if (debug) {Serial.println(current_temp1);}
    if ((old_temperature1!=(int)current_temp1) && (current_temp1<79) && (current_temp1>5)) {
      int temp1 = (current_temp1 - (int)current_temp1) * 100; // выделяем дробную часть
      //sprintf(buf, "GET /objects/?object=SensorZal&op=m&m=tempChanged&t=%0d.%d", (int)current_temp1, abs(temp1));   
      //sendHTTPRequest();
    }
  old_temperature1=(int)current_temp1;
  }
}



void website()
{
EthernetClient client = server.available();
  if (client) {
    Serial.println("new client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      if (client.available()) {
        char c = client.read();
        Serial.write(c);
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {
          // send a standard http response header
          client.println("HTTP/1.1 200 OK");
          client.println("Content-Type: text/html");
          client.println("Connection: close");  // the connection will be closed after completion of the response
	  client.println("Refresh: 30");  // refresh the page automatically every 5 sec
          client.println();
          client.println("<!DOCTYPE HTML>");
          client.println("<html>");
          // output the value of each analog input pin
          ///////////////////////////////////////////
            // send web page
                    webFile = SD.open("index.htm");        // open web page file
                    if (webFile) {
                        while(webFile.available()) {
                           //Serial.println("site");
                           char simv=webFile.read();
                          // Serial.println(f);
                          if (simv=='~') {
                                simv=webFile.read();
                                switch (simv) {
                                case '1':
                                 client.print(tempIn);
                                 break; 
                                case 'Q':
                                 client.print(tempIn_min);
                                 break;
                                case 'W':
                                 client.print(tempIn_max);
                                 break;
                                case 'A': 
                                 client.print(StrTime(tempIn_min_time));
                                 break;
                                case 'S': 
                                 client.print(StrTime(tempIn_max_time));
                                 break;
                                case '2':
                                 client.print(hum);
                                 break;
                                case 'T':
                                 client.print(hum_min);
                                 break;
                                case 'Y':
                                 client.print(hum_max);
                                 break;
                                case 'D':
                                 client.print(StrTime(hum_min_time));
                                 break;
                                case 'F':
                                 client.print(StrTime(hum_max_time));
                                 break;
                                case '3':
                                 client.print(current_temp1);
                                 break;
                                case 'E':
                                 client.print(current_temp1_min);
                                 break;
                                case 'R':
                                 client.print(current_temp1_max);
                                 break;
                                case 'G':
                                 client.print(StrTime(current_temp1_min_time));
                                 break;
                                case 'H':
                                 client.print(StrTime(current_temp1_max_time));
                                 break;
                                case '4':
                                 client.print(cur_pressure);
                                 break;
                                case 'U':
                                 client.print(cur_pressure_min);
                                 break;
                                case 'I':
                                 client.print(cur_pressure_max);
                                 break;
                                case 'J':
                                 client.print(StrTime(cur_pressure_min_time));
                                 break;
                                case 'K':
                                 client.print(StrTime(cur_pressure_max_time));
                                 break;
                                }
                          simv=' ';
                          }
                          client.write(simv);
                          // Serial.write(webFile.read()); // send web page to client
                        }
                        webFile.close();
                    }
          //////////////////////////////////////////
        break;
        }
        if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        } 
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    client.stop();
    Serial.println("client disonnected");
  }
}


void GetTempInHum() {
  // Reading temperature or humidity takes about 250 milliseconds!
  // Sensor readings may also be up to 2 seconds 'old' (its a very slow sensor)
  hum = dht.readHumidity();
  tempIn = dht.readTemperature();

  // check if returns are valid, if they are NaN (not a number) then something went wrong!
 if (debug) { 
  if (isnan(tempIn) || isnan(hum)) {
    Serial.println("Failed to read from DHT");
  } else {
    Serial.print("Humidity: "); 
    Serial.print(hum);
    Serial.print(" %\t");
    Serial.print("Temperature: "); 
    Serial.print(tempIn);
    Serial.println(" *C");
  }
 }
}

void GetPressure() { 
  dps.getPressure(&Pressure); 
  if (debug) {   
  Serial.print("  Pressure(mm Hg):"); 
  Serial.println(Pressure/133.3);
 cur_pressure= Pressure/133.3;
  }
}

void Print(){
lcd.setCursor(0,0);

lcd.print("In: "); // print a simple message   
lcd.print(int(tempIn));
lcd.print("C ");
lcd.print("H:"); // print a simple message   
lcd.print(hum);
lcd.print("%");

lcd.setCursor(0,1);
lcd.print("Out:"); // print a simple message   
lcd.print(int(current_temp1));
lcd.print("C ");
lcd.print("P:"); // print a simple message   
lcd.print(cur_pressure);
lcd.print("mm H");
}

String StrTime(unsigned long time)
{
 String StrT;
    StrT=String((time  % 86400L) / 3600)+':'; // print the hour (86400 equals secs per day) 
    Serial.println("print the hour (86400 equals secs per day)");
    Serial.println(time);
    Serial.println(StrT);
    if ( ((time % 3600) / 60) < 10 ) {
      // In the first 10 minutes of each hour, we'll want a leading '0'
      StrT=StrT+'0';
    }
    StrT=StrT+String((time  % 3600) / 60); // print the minute (3600 equals secs per minute)
   return StrT;
}


// send an NTP request to the time server at the given address 
unsigned long sendNTPpacket(IPAddress& address)
{
  // set all bytes in the buffer to 0
  memset(packetBuffer, 0, NTP_PACKET_SIZE); 
  // Initialize values needed to form NTP request
  // (see URL above for details on the packets)
  packetBuffer[0] = 0b11100011;   // LI, Version, Mode
  packetBuffer[1] = 0;     // Stratum, or type of clock
  packetBuffer[2] = 6;     // Polling Interval
  packetBuffer[3] = 0xEC;  // Peer Clock Precision
  // 8 bytes of zero for Root Delay & Root Dispersion
  packetBuffer[12]  = 49; 
  packetBuffer[13]  = 0x4E;
  packetBuffer[14]  = 49;
  packetBuffer[15]  = 52;

  // all NTP fields have been given values, now
  // you can send a packet requesting a timestamp: 		   
  Udp.beginPacket(address, 123); //NTP requests are to port 123
  Udp.write(packetBuffer,NTP_PACKET_SIZE);
  Udp.endPacket(); 
}

// ------------------------------------------------------------------------------------------------
void loop()
{
  
if (millis() - lastReadingTime > 1000*20){
//получаю время из инета
sendNTPpacket(timeServer); // send an NTP packet to a time server
 delay(1000);  
 
 if ( Udp.parsePacket() ) { 
  Serial.println("// We've received a packet, read the data from it:"); 
    // We've received a packet, read the data from it
    Udp.read(packetBuffer,NTP_PACKET_SIZE);  // read the packet into the buffer

    //the timestamp starts at byte 40 of the received packet and is four bytes,
    // or two words, long. First, esxtract the two words:

    unsigned long highWord = word(packetBuffer[40], packetBuffer[41]);
    unsigned long lowWord = word(packetBuffer[42], packetBuffer[43]);  
    // combine the four bytes (two words) into a long integer
    // this is NTP time (seconds since Jan 1 1900):
    unsigned long secsSince1900 = highWord << 16 | lowWord;  
    secsSince1900 = secsSince1900+345600;
    Serial.print("Seconds since Jan 1 1900 = " );
    Serial.println(secsSince1900);               

    // now convert NTP time into everyday time:
    Serial.print("Unix time = ");
    // Unix time starts on Jan 1 1970. In seconds, that's 2208988800:
    const unsigned long seventyYears = 2208988800UL;     
    // subtract seventy years:
    epoch = secsSince1900 - seventyYears;  
    // print Unix time:
    epoch = secsSince1900 +3600*4; //поправка часового пояся
    Serial.println(epoch);                               


    // print the hour, minute and second:
    Serial.print("The UTC time is ");       // UTC is the time at Greenwich Meridian (GMT)
    Serial.print((epoch  % 86400L) / 3600); // print the hour (86400 equals secs per day)
    //Обнуляем минимумы и максимумы
    if (((epoch%86400L)/3600 == 0) && first==false && ((epoch  % 3600) / 60)==0) {first=true;}
    Serial.print(':');  
    if ( ((epoch % 3600) / 60) < 10 ) {
      // In the first 10 minutes of each hour, we'll want a leading '0'
      Serial.print('0');
    }
    Serial.print((epoch  % 3600) / 60); // print the minute (3600 equals secs per minute)
    Serial.print(':'); 
    if ( (epoch % 60) < 10 ) {
      // In the first 10 seconds of each minute, we'll want a leading '0'
      Serial.print('0');
    }
    Serial.println(epoch %60); // print the second
  }
  // wait ten seconds before asking for the time again
  
/////////////////////////////////////////////
 
    // if there's a reading ready, read it:
    // don't do anything until the data ready pin is high:
      GetTemp();
      
      GetTempInHum();
       
      GetPressure();
      
      if (first) {
      tempIn_min=tempIn_max=tempIn;
      current_temp1_max=current_temp1_min=current_temp1;
      hum_min=hum_max=hum;
      cur_pressure_min=cur_pressure_max=cur_pressure;
      tempIn_min_time=tempIn_max_time=hum_min_time=hum_max_time=current_temp1_min_time=current_temp1_max_time=cur_pressure_min_time=cur_pressure_max_time=epoch;
      first=false;}
      
      if (tempIn<tempIn_min) {
         tempIn_min=tempIn;
         tempIn_min_time=epoch;}
      if (tempIn>tempIn_max) {
         tempIn_max=tempIn;
         tempIn_max_time=epoch;} 
        
      if (hum<hum_min) {
         hum_min=hum;
         hum_min_time=epoch;}
      if (hum>hum_max) {
         hum_max=hum;
         hum_max_time=epoch;}  
      
      if (current_temp1<current_temp1_min) {
         current_temp1_min=current_temp1;
         current_temp1_min_time=epoch;}
      if (current_temp1>current_temp1_max) {
         current_temp1_max=current_temp1;
         current_temp1_max_time=epoch;}
      
      if (cur_pressure<cur_pressure_min) {
         cur_pressure_min=cur_pressure;
         cur_pressure_min_time=epoch;}
      if (cur_pressure>cur_pressure_max) {
         cur_pressure_max=cur_pressure;
         cur_pressure_max_time=epoch;}
      
      //GetPower();
      lastReadingTime = millis();
      Print();
  }
 website();

}
